; X-Link64 v.01b
; Client source for Commodore 64
; (c) 1997-98 Piotr Tracz / Color7 Productions
; fixed in 1999 - thanks to Stilgar for bug report!!!
; however C64 NMI-back and start routine is still not stable.
; start environment might be also a lot better...


         *= $033c


nmi      sei
         lda #<nmi
         sta $0318
         lda #>nmi
         sta $0319
         lda #$0b
         sta $d011
         sta $d020
         lda #$00
         sta $dd01
         lda #$04
         sta $dd02
         lda #$0f
         sta $dd03
start    jsr get
         sta $fb
         jsr get
         sta $fc
         jsr get
         cmp #$00
         beq s2_
         sta run+2
         jsr get
         sta run+1
         jmp s2
s2_      jsr get
s2       jsr get
         clc
         adc $fb
         sta mb+1
         php
         jsr get
         plp
         adc $fc
         sta sb+1
         lda #$35
         sta $01
         ldy #$00
next     jsr get
         dec $01
         sta ($fb),y
         inc $01
         inc $fb
         bne s3
         inc $fc
s3       lda $fb
mb       cmp #$00
         bne next
         lda $fc
sb       cmp #$00
         bne next
         lda #$37
         sta $01
         cli
run      jmp start

get      lda $dd0d
         and #%00010000
         beq get
         lda $dd01
         lsr a
         lsr a
         lsr a
         lsr a
         sta $02
         lda #$01
         sta $dd01
wait_1   lda $dd0d
         and #%00010000
         beq wait_1
         lda $dd01
         and #%11110000
         ora $02
         ldy #$00
         sty $dd01
         inc $d020
         rts

